aboutsummaryrefslogtreecommitdiffhomepage
diff options
context:
space:
mode:
authorGravatar Zhouyihai Ding <ddyihai@google.com>2017-09-21 14:18:53 -0700
committerGravatar GitHub <noreply@github.com>2017-09-21 14:18:53 -0700
commita1f7f513a78c9223354ff92a57a723a08d2d82d2 (patch)
tree007f2bc22381b2132f3365b7125f9ee0ca7b51a5
parent6bdd49b3ce78832bb09d017ee7562816e2dce7dc (diff)
parent7115862e98059b3fbd2069ae7ad1bf09232a416e (diff)
Merge pull request #12675 from grpc/revert-12674-revert-10126-phpqps_auto
Revert "Revert "Add automated PHP-to-C++ performance testing""
-rwxr-xr-xtools/gce/linux_performance_worker_init.sh5
-rwxr-xr-xtools/run_tests/performance/run_worker_php.sh28
-rw-r--r--tools/run_tests/performance/scenario_config.py28
3 files changed, 61 insertions, 0 deletions
diff --git a/tools/gce/linux_performance_worker_init.sh b/tools/gce/linux_performance_worker_init.sh
index 8f0a0f65c3..88d8de7402 100755
--- a/tools/gce/linux_performance_worker_init.sh
+++ b/tools/gce/linux_performance_worker_init.sh
@@ -128,6 +128,11 @@ ruby -v
# Install bundler (prerequisite for gRPC Ruby)
gem install bundler
+# PHP dependencies
+sudo apt-get install -y php php-dev phpunit php-pear unzip zlib1g-dev
+curl -sS https://getcomposer.org/installer | php
+sudo mv composer.phar /usr/local/bin/composer
+
# Java dependencies - nothing as we already have Java JDK 8
# Go dependencies
diff --git a/tools/run_tests/performance/run_worker_php.sh b/tools/run_tests/performance/run_worker_php.sh
new file mode 100755
index 0000000000..5d0c4fa4fd
--- /dev/null
+++ b/tools/run_tests/performance/run_worker_php.sh
@@ -0,0 +1,28 @@
+#!/bin/bash
+# Copyright 2017 gRPC authors.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+source ~/.rvm/scripts/rvm
+set -ex
+
+repo=$(dirname $0)/../../..
+
+# First set up all dependences needed for PHP QPS test
+cd $repo
+cd src/php/tests/qps
+composer install
+# The proxy worker for PHP is implemented in Ruby
+cd ../../../..
+ruby src/ruby/qps/proxy-worker.rb $@
+
diff --git a/tools/run_tests/performance/scenario_config.py b/tools/run_tests/performance/scenario_config.py
index a7560400dd..5efc9f5648 100644
--- a/tools/run_tests/performance/scenario_config.py
+++ b/tools/run_tests/performance/scenario_config.py
@@ -800,6 +800,33 @@ class RubyLanguage:
return 'ruby'
+class PhpLanguage:
+
+ def __init__(self):
+ pass
+ self.safename = str(self)
+
+ def worker_cmdline(self):
+ return ['tools/run_tests/performance/run_worker_php.sh']
+
+ def worker_port_offset(self):
+ return 800
+
+ def scenarios(self):
+ yield _ping_pong_scenario(
+ 'php_to_cpp_protobuf_sync_unary_ping_pong', rpc_type='UNARY',
+ client_type='SYNC_CLIENT', server_type='SYNC_SERVER',
+ server_language='c++', async_server_threads=1)
+
+ yield _ping_pong_scenario(
+ 'php_to_cpp_protobuf_sync_streaming_ping_pong', rpc_type='STREAMING',
+ client_type='SYNC_CLIENT', server_type='SYNC_SERVER',
+ server_language='c++', async_server_threads=1)
+
+ def __str__(self):
+ return 'php'
+
+
class JavaLanguage:
def __init__(self):
@@ -997,6 +1024,7 @@ LANGUAGES = {
'node' : NodeLanguage(),
'node_express': NodeExpressLanguage(),
'ruby' : RubyLanguage(),
+ 'php' : PhpLanguage(),
'java' : JavaLanguage(),
'python' : PythonLanguage(),
'go' : GoLanguage(),